package xyz.twovb.sgm.games;

/*
 * Created by 2vb - 4/6/2024
 */

import org.bukkit.NamespacedKey;
import org.bukkit.World;
import org.bukkit.WorldCreator;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import xyz.twovb.sgm.SGM;
import xyz.twovb.sgm.levels.LevelManager;
import xyz.twovb.toolbox.api.CustomPlayer;

import java.util.List;
import java.util.UUID;

public interface Minigame extends Listener {

    void init(CommandSender owner, String world);

    void start();

    void stop();

    void addPlayer(Player player);

    void removePlayer(Player player);

    List<Player> getPlayers();

    void onTick();

    String getName();

    UUID getGameId();

    GameState getState();

    CommandSender getOwner();

    default void sendMessageToAllPlayers(String message) {
        for (Player player : getPlayers()) {
            CustomPlayer cPlayer = new CustomPlayer(player);
            cPlayer.sendMessage(message);
        }
    }

    default World createGameWorld(String name) {
        WorldCreator wc = new WorldCreator(LevelManager.path + name, new NamespacedKey(SGM.getInstance(), name + "-" + UUID.randomUUID()));
        World world = wc.createWorld();
        if (world == null) return null;
        world.setAutoSave(false);
        return world;
    }

    enum GameState {
        PRESTART, READY, STARTED, ENDING
    }

}
